/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

/**********************************************************************

	--- Qt Architect generated file ---

	File: spgram.cpp
	Last generated: Wed Jan 6 02:29:52 1999

 *********************************************************************/

#include "spgram.h"
#include "main.h"
#include "fft.h"
#include <math.h>
#include <qscrollbar.h>

#define Inherited spgramData

extern cnf mconf;

spgram::spgram
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
mconf.pg.pn=256;
mconf.pg.zoom=1;
mconf.pg.window_start=0;
zoom_lcd->display(mconf.pg.zoom);
}

void spgram::con(bool i)
{
   mconf.pg.con=i;
   sd->update();
}

void spgram::con_value(int i)
{
  mconf.pg.con_value=i;
   sd->update();
}

void spgram::black_value(int i)
{
  mconf.pg.black_value=i;
   sd->update();}

void spgram::black(bool i)
{
  mconf.pg.black=i;
   sd->update();}

void spgram::cut(bool i)
{
  mconf.pg.cut=i;
   sd->update();}

void spgram::cut_value(int i)
{
  mconf.pg.cut_value=i;
   sd->update();}

void spgram::reinit_scbar()
{
int h=height();
int w=width();

scbar->close();
scbar=new QScrollBar(0,mconf.pg.window_number-mconf.pg.window_length,1,mconf.pg.window_length,0,QScrollBar::Horizontal,this);
scbar->resize(w-235,15);
scbar->move(20,h-30);
connect(scbar,SIGNAL(valueChanged(int)),SLOT(start_ch(int)));
scbar->show();
mconf.pg.window_start=0;
sd->update();
}

void spgram::logcol(bool i)
{
  mconf.pg.logcol=i;
   sd->update();}

void spgram::start_ch(int i)
{
  mconf.pg.window_start=i;
  winstart_lcd->display(i*mconf.pg.pn/(mconf.wave.freq/100));
  sd->repaint(TRUE);
}

void spgram::zoom_inc()
{
   mconf.pg.zoom++;
   mconf.pg.window_length=mconf.pg.window_number/mconf.pg.zoom;
   zoom_lcd->display(mconf.pg.zoom);
   reinit_scbar();
}

void spgram::zoom_dec()
{
if (mconf.pg.zoom>1)
   mconf.pg.zoom--;
   mconf.pg.window_length=mconf.pg.window_number/mconf.pg.zoom;
   zoom_lcd->display(mconf.pg.zoom);
   reinit_scbar();
}

void spgram::window_ch(int i)
{
   mconf.spect.window=i;
}

void spgram::pn_ch(int i)
{
   switch (i)
	{
		case 0:	mconf.pg.pn=128;break;
		case 1:	mconf.pg.pn=256;break;
		case 2:	mconf.pg.pn=512;break;
		case 3:	mconf.pg.pn=1024;break;
		case 4:	mconf.pg.pn=2048;break;
		case 5:	mconf.pg.pn=4096;break;
		case 6:	mconf.pg.pn=8192;break;
	}
}

void spgram::start_fft()
{
int i,j,k;
float maxp;
int ln;
Fft fft;

mconf.pg.window_number=mconf.wave.rec_pn/mconf.pg.pn;
mconf.pg.val=(float **)calloc(mconf.pg.window_number,4);
for (i=0;i<mconf.pg.window_number;i++)
{
  *(mconf.pg.val+i)=(float *)calloc(mconf.pg.pn/2+1,sizeof(float));
}
mconf.spect.source=(complex *)calloc(mconf.pg.pn+1,sizeof(complex));
ln=(int)((float)(log((float)mconf.pg.pn)/log((float)2)));
fft.init(ln);
mconf.pg.window_length=mconf.pg.window_number;
for (i=0;i<mconf.pg.window_number;i++)
{
  fft.cp_datas(i*mconf.pg.pn,(i+1)*mconf.pg.pn-1,mconf.wave.wave);
  fft.fft();
  for (k=0;k<=mconf.pg.pn/2;k++)
  {
     *( (*(mconf.pg.val+i)) +k)=*(mconf.spect.power+k);
  }
}
maxp=0;
for (i=0;i<mconf.pg.window_number;i++)
{
  for (j=2;j<mconf.pg.pn/2;j++)
  {
     if ( *( (*(mconf.pg.val+i)) +j)>maxp ) maxp=*( (*(mconf.pg.val+i)) +j);
  }
}
mconf.spect.maxpower=maxp;
mconf.pg.zoom=1;
zoom_lcd->display(mconf.pg.zoom);
reinit_scbar();
}

void spgram::resizeEvent(QResizeEvent *p)
{
int h=height();
int w=width();

l1->move(w-200,20);
l2->move(w-200,50);
l3->move(w-195,90);
l4->move(w-195,120);
l5->move(w-40,50);
chb1->move(w-195,175);
chb2->move(w-195,200);
chb3->move(w-195,235);
chb4->move(w-195,265);
b1->move(w-120,15);
b2->move(w-40,15);
b3->move(w-205,h-45);
b4->move(w-95,h-45);
zoom_lcd->move(w-90,15);
winstart_lcd->move(w-90,50);
cb1->move(w-115,90);
cb2->move(w-95,120);
sb1->move(w-95,170);
sb2->move(w-95,200);
sb3->move(w-95,230);
fr1->move(w-205,80);
fr2->move(w-205,160);
fr3->resize(w-225,h-25);
scbar->resize(w-235,15);
scbar->move(20,h-30);
sd->resize(w-235,h-55);
}

void spgram::cancel()
{
  reject();
}

spgram::~spgram()
{
}
